/*----- PROTECTED REGION ID(Tpg300.cpp) ENABLED START -----*/
static const char *RcsId = "$Id: Tpg300.cpp,v 1.8 2016-10-18 15:53:02 claudio Exp $";
//=============================================================================
//
// file :        Tpg300.cpp
//
// description : C++ source for the Tpg300 and its commands.
//               The class is derived from Device. It represents the
//               CORBA servant object which will be accessed from the
//               network. All commands which can be executed on the
//               Tpg300 are implemented in this file.
//
// project :     Balzer Tpg 300.
//
// $Author: claudio $
//
// $Revision: 1.8 $
// $Date: 2016-10-18 15:53:02 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/tpg300/src/Tpg300.cpp,v $
// $Log: Tpg300.cpp,v $
// Revision 1.8  2016-10-18 15:53:02  claudio
// tango9
//
// Revision 1.7  2013-06-12 09:57:05  lorenzo
// Added DeviceState and DeviceStatus attributes
//
// Revision 1.6  2013-06-05 14:59:10  lorenzo
// Tango 8.0.5
//
// Revision 1.5  2012-09-10 08:01:04  mdm
// Bugfix in thread and on off commands
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tpg300.h>
#include <Tpg300Class.h>
#include <Tpg300Proxy.h>
#include <Tpg300Error.h>
#include <Tpg300SPManager.h>
#include <Tpg300Channel.h>
#include <Tpg300Thread.h>
#include <Tpg300Utils.h>

#include "devicestate.h"

/*----- PROTECTED REGION END -----*/	//	Tpg300.cpp

/**
 *  Tpg300 class description:
 *    Total pressure gauge and controller
 */

//================================================================
//  The following table gives the correspondence
//  between command and method names.
//
//  Command name         |  Method name
//================================================================
//  State                |  Inherited (no method)
//  Status               |  Inherited (no method)
//  SensorOn             |  sensor_on
//  SensorOff            |  sensor_off
//  WriteLowerThreshold  |  write_lower_threshold
//  ReadLowerThreshold   |  read_lower_threshold
//  WriteUpperThreshold  |  write_upper_threshold
//  ReadUpperThreshold   |  read_upper_threshold
//  ReadSensorSource     |  read_sensor_source
//  WriteSensorSource    |  write_sensor_source
//  RegisterName         |  register_name
//  UnregisterName       |  unregister_name
//================================================================

//================================================================
//  Attributes managed are:
//================================================================
//  Pressure_0      |  Tango::DevDouble	Scalar
//  Pressure_1      |  Tango::DevDouble	Scalar
//  Pressure_2      |  Tango::DevDouble	Scalar
//  Pressure_3      |  Tango::DevDouble	Scalar
//  State_0         |  Tango::DevState	Scalar
//  State_1         |  Tango::DevState	Scalar
//  State_2         |  Tango::DevState	Scalar
//  State_3         |  Tango::DevState	Scalar
//  Status_0        |  Tango::DevString	Scalar
//  Status_1        |  Tango::DevString	Scalar
//  Status_2        |  Tango::DevString	Scalar
//  Status_3        |  Tango::DevString	Scalar
//  Name_0          |  Tango::DevString	Scalar
//  Name_1          |  Tango::DevString	Scalar
//  Name_2          |  Tango::DevString	Scalar
//  Name_3          |  Tango::DevString	Scalar
//  DeviceState     |  Tango::DevUChar	Scalar
//  DeviceStatus    |  Tango::DevString	Scalar
//  SetPointStatus  |  Tango::DevBoolean	Spectrum  ( max = 6)
//================================================================

namespace Tpg300_ns
{
/*----- PROTECTED REGION ID(Tpg300::namespace_starting) ENABLED START -----*/

	//	static initializations

	/*----- PROTECTED REGION END -----*/	//	Tpg300::namespace_starting

//--------------------------------------------------------
/**
 *	Method     : Tpg300::Tpg300()
 *	Description: Constructors for a Tango device
 *                implementing the classTpg300
 */
//--------------------------------------------------------
Tpg300::Tpg300(Tango::DeviceClass *cl, std::string &s)
 : TANGO_BASE_CLASS(cl, s.c_str())
{
	/*----- PROTECTED REGION ID(Tpg300::constructor_1) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Tpg300::constructor_1
}
//--------------------------------------------------------
Tpg300::Tpg300(Tango::DeviceClass *cl, const char *s)
 : TANGO_BASE_CLASS(cl, s)
{
	/*----- PROTECTED REGION ID(Tpg300::constructor_2) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Tpg300::constructor_2
}
//--------------------------------------------------------
Tpg300::Tpg300(Tango::DeviceClass *cl, const char *s, const char *d)
 : TANGO_BASE_CLASS(cl, s, d)
{
	/*----- PROTECTED REGION ID(Tpg300::constructor_3) ENABLED START -----*/

	init_device();

	/*----- PROTECTED REGION END -----*/	//	Tpg300::constructor_3
}
//--------------------------------------------------------
Tpg300::~Tpg300()
{
	delete_device();
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::delete_device()
 *	Description: will be called at device destruction or at init command
 */
//--------------------------------------------------------
void Tpg300::delete_device()
{
	DEBUG_STREAM << "Tpg300::delete_device() " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::delete_device) ENABLED START -----*/

	DEBUG_STREAM << "Tpg300::delete_device() delete device " << device_name << endl;

	if(thread)
	{
		thread->kill_thread();

		unsigned long sec;
		unsigned long nsec;

		unsigned long timeout_sec = timeout/1000;
		unsigned long timeout_nsec = (timeout%1000)*1000000;

		omni_thread::get_time(&sec, &nsec, timeout_sec,  timeout_nsec);

		stop_condition->timedwait(sec, nsec);

		thread = 0;
	}

	if(channel_0)
	{
		delete channel_0;
		channel_0 = 0;
	}
	if(channel_1)
	{
		delete channel_1;
		channel_1 = 0;
	}
	if(channel_2)
	{
		delete channel_2;
		channel_2 = 0;
	}
	if(channel_3)
	{
		delete channel_3;
		channel_3 = 0;
	}

	if(sp_manager)
	{
		delete sp_manager;
		sp_manager = 0;
	}

	if(error_status)
	{
		delete error_status;
		error_status = 0;
	}

	if(proxy)
	{
		delete proxy;
		proxy = 0;
	}

	delete stop_condition;
	delete stop_mutex;


	Tpg300Utils::string_free(attr_Status_0_read);
	Tpg300Utils::string_free(attr_Status_1_read);
	Tpg300Utils::string_free(attr_Status_2_read);
	Tpg300Utils::string_free(attr_Status_3_read);

	Tpg300Utils::string_free(attr_Name_0_read);
	Tpg300Utils::string_free(attr_Name_1_read);
	Tpg300Utils::string_free(attr_Name_2_read);
	Tpg300Utils::string_free(attr_Name_3_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::delete_device
	delete[] attr_Pressure_0_read;
	delete[] attr_Pressure_1_read;
	delete[] attr_Pressure_2_read;
	delete[] attr_Pressure_3_read;
	delete[] attr_State_0_read;
	delete[] attr_State_1_read;
	delete[] attr_State_2_read;
	delete[] attr_State_3_read;
	delete[] attr_Status_0_read;
	delete[] attr_Status_1_read;
	delete[] attr_Status_2_read;
	delete[] attr_Status_3_read;
	delete[] attr_Name_0_read;
	delete[] attr_Name_1_read;
	delete[] attr_Name_2_read;
	delete[] attr_Name_3_read;
	delete[] attr_DeviceState_read;
	delete[] attr_DeviceStatus_read;
	delete[] attr_SetPointStatus_read;
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::init_device()
 *	Description: will be called at device initialization.
 */
//--------------------------------------------------------
void Tpg300::init_device()
{
	DEBUG_STREAM << "Tpg300::init_device() create device " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::init_device_before) ENABLED START -----*/

	set_state(Tango::INIT);
	set_status("Device server initialization");

	proxy = 0;

	error_status = 0;

	sp_manager = 0;

	channel_0 = 0;
	channel_1 = 0;
	channel_2 = 0;
	channel_3 = 0;

	thread = 0;

	init_completed = false;

	/*----- PROTECTED REGION END -----*/	//	Tpg300::init_device_before


	//	Get the device properties from database
	get_device_property();

	attr_Pressure_0_read = new Tango::DevDouble[1];
	attr_Pressure_1_read = new Tango::DevDouble[1];
	attr_Pressure_2_read = new Tango::DevDouble[1];
	attr_Pressure_3_read = new Tango::DevDouble[1];
	attr_State_0_read = new Tango::DevState[1];
	attr_State_1_read = new Tango::DevState[1];
	attr_State_2_read = new Tango::DevState[1];
	attr_State_3_read = new Tango::DevState[1];
	attr_Status_0_read = new Tango::DevString[1];
	attr_Status_1_read = new Tango::DevString[1];
	attr_Status_2_read = new Tango::DevString[1];
	attr_Status_3_read = new Tango::DevString[1];
	attr_Name_0_read = new Tango::DevString[1];
	attr_Name_1_read = new Tango::DevString[1];
	attr_Name_2_read = new Tango::DevString[1];
	attr_Name_3_read = new Tango::DevString[1];
	attr_DeviceState_read = new Tango::DevUChar[1];
	attr_DeviceStatus_read = new Tango::DevString[1];
	attr_SetPointStatus_read = new Tango::DevBoolean[6];
	/*----- PROTECTED REGION ID(Tpg300::init_device) ENABLED START -----*/

	Tpg300Utils::string_alloc(attr_Status_0_read);
	Tpg300Utils::string_alloc(attr_Status_1_read);
	Tpg300Utils::string_alloc(attr_Status_2_read);
	Tpg300Utils::string_alloc(attr_Status_3_read);

	Tpg300Utils::string_alloc(attr_Name_0_read);
	Tpg300Utils::string_alloc(attr_Name_1_read);
	Tpg300Utils::string_alloc(attr_Name_2_read);
	Tpg300Utils::string_alloc(attr_Name_3_read);

	stop_mutex = new omni_mutex();
	stop_condition = new omni_condition(stop_mutex);

	if(get_state() != Tango::FAULT)
	{
		try
		{
			proxy = new Tpg300Proxy(serialDevice, timeout, proxySleep);

			proxy->write_read("UNI,1");

			vector<Tpg300Task *> task_vector;

			error_status = new Tpg300Error(proxy);
			task_vector.push_back(error_status);

			sp_manager = new Tpg300SPManager(proxy);
			task_vector.push_back(sp_manager);

			channel_0 = new Tpg300Channel(proxy, Tpg300Channel::CHANNEL_0);
			task_vector.push_back(channel_0);

			channel_1 = new Tpg300Channel(proxy, Tpg300Channel::CHANNEL_1);
			task_vector.push_back(channel_1);

			channel_2 = new Tpg300Channel(proxy, Tpg300Channel::CHANNEL_2);
			task_vector.push_back(channel_2);

			channel_3 = new Tpg300Channel(proxy, Tpg300Channel::CHANNEL_3);
			task_vector.push_back(channel_3);

			thread = new Tpg300Thread(task_vector, threadSleep, stop_condition);

			init_completed = true;
		}
		catch(Tango::DevFailed& ex)
		{
			set_state( Tango::FAULT );
			set_status( Tpg300Utils::get_trace(ex) );
		}
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::init_device
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::get_device_property()
 *	Description: Read database to initialize property data members.
 */
//--------------------------------------------------------
void Tpg300::get_device_property()
{
	/*----- PROTECTED REGION ID(Tpg300::get_device_property_before) ENABLED START -----*/

	//	Initialize property data members

	/*----- PROTECTED REGION END -----*/	//	Tpg300::get_device_property_before


	//	Read device properties from database.
	Tango::DbData	dev_prop;
	dev_prop.push_back(Tango::DbDatum("SerialDevice"));
	dev_prop.push_back(Tango::DbDatum("Timeout"));
	dev_prop.push_back(Tango::DbDatum("ThreadSleep"));
	dev_prop.push_back(Tango::DbDatum("ProxySleep"));

	//	is there at least one property to be read ?
	if (dev_prop.size()>0)
	{
		//	Call database and extract values
		if (Tango::Util::instance()->_UseDb==true)
			get_db_device()->get_property(dev_prop);

		//	get instance on Tpg300Class to get class property
		Tango::DbDatum	def_prop, cl_prop;
		Tpg300Class	*ds_class =
			(static_cast<Tpg300Class *>(get_device_class()));
		int	i = -1;

		//	Try to initialize SerialDevice from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  serialDevice;
		else {
			//	Try to initialize SerialDevice from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  serialDevice;
		}
		//	And try to extract SerialDevice value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  serialDevice;

		//	Try to initialize Timeout from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  timeout;
		else {
			//	Try to initialize Timeout from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  timeout;
		}
		//	And try to extract Timeout value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  timeout;

		//	Try to initialize ThreadSleep from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  threadSleep;
		else {
			//	Try to initialize ThreadSleep from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  threadSleep;
		}
		//	And try to extract ThreadSleep value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  threadSleep;

		//	Try to initialize ProxySleep from class property
		cl_prop = ds_class->get_class_property(dev_prop[++i].name);
		if (cl_prop.is_empty()==false)	cl_prop  >>  proxySleep;
		else {
			//	Try to initialize ProxySleep from default device value
			def_prop = ds_class->get_default_device_property(dev_prop[i].name);
			if (def_prop.is_empty()==false)	def_prop  >>  proxySleep;
		}
		//	And try to extract ProxySleep value from database
		if (dev_prop[i].is_empty()==false)	dev_prop[i]  >>  proxySleep;

	}

	/*----- PROTECTED REGION ID(Tpg300::get_device_property_after) ENABLED START -----*/

	if(dev_prop[0].is_empty())
	{
		set_state(Tango::FAULT);
		set_status("SerialDevice property not defined");
		return;
	}

	if(serialDevice.empty() || serialDevice.compare("undefined") == 0)
	{
		set_state(Tango::FAULT);
		set_status("SerialDevice property is empty");
		return;
	}

    if(dev_prop[1].is_empty())
    {
		WARN_STREAM << "Timeout property not defined, default: " << timeout << endl;
    }

    if(timeout < 1 || timeout > 10000)
    {
		set_state(Tango::FAULT);
		set_status("Timeout invalid value, valid range [1,10000]");
		return;
    }

    if(dev_prop[2].is_empty())
    {
		WARN_STREAM << "ThreadSleep property not defined, default: " << threadSleep << endl;
    }

    if(threadSleep < 1 || threadSleep > 10000)
    {
		set_state(Tango::FAULT);
		set_status("ThreadSleep invalid value, valid range [1,10000]");
		return;
    }

    if(dev_prop[3].is_empty())
    {
		WARN_STREAM << "ProxySleep property not defined, default: " << proxySleep << endl;
    }

    if(proxySleep < 1 || proxySleep > 10000)
    {
		set_state(Tango::FAULT);
		set_status("ProxySleep invalid value, valid range [1,10000]");
		return;
    }

	/*----- PROTECTED REGION END -----*/	//	Tpg300::get_device_property_after
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::always_executed_hook()
 *	Description: method always executed before any command is executed
 */
//--------------------------------------------------------
void Tpg300::always_executed_hook()
{
	DEBUG_STREAM << "Tpg300::always_executed_hook()  " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::always_executed_hook) ENABLED START -----*/

	if(init_completed)
	{
		update_state();

		update_status();
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::always_executed_hook
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::read_attr_hardware()
 *	Description: Hardware acquisition for attributes
 */
//--------------------------------------------------------
void Tpg300::read_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Tpg300::read_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_attr_hardware) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_attr_hardware
}
//--------------------------------------------------------
/**
 *	Method     : Tpg300::write_attr_hardware()
 *	Description: Hardware writing for attributes
 */
//--------------------------------------------------------
void Tpg300::write_attr_hardware(TANGO_UNUSED(std::vector<long> &attr_list))
{
	DEBUG_STREAM << "Tpg300::write_attr_hardware(std::vector<long> &attr_list) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::write_attr_hardware) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Tpg300::write_attr_hardware
}

//--------------------------------------------------------
/**
 *	Read attribute Pressure_0 related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Pressure_0(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Pressure_0(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Pressure_0) ENABLED START -----*/

	*attr_Pressure_0_read = channel_0->get_pressure();

	attr.set_value(attr_Pressure_0_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Pressure_0
}
//--------------------------------------------------------
/**
 *	Read attribute Pressure_1 related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Pressure_1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Pressure_1(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Pressure_1) ENABLED START -----*/

	*attr_Pressure_1_read = channel_1->get_pressure();

	attr.set_value(attr_Pressure_1_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Pressure_1
}
//--------------------------------------------------------
/**
 *	Read attribute Pressure_2 related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Pressure_2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Pressure_2(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Pressure_2) ENABLED START -----*/

	*attr_Pressure_2_read = channel_2->get_pressure();

	attr.set_value(attr_Pressure_2_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Pressure_2
}
//--------------------------------------------------------
/**
 *	Read attribute Pressure_3 related method
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Pressure_3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Pressure_3(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Pressure_3) ENABLED START -----*/

	*attr_Pressure_3_read = channel_3->get_pressure();

	attr.set_value(attr_Pressure_3_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Pressure_3
}
//--------------------------------------------------------
/**
 *	Read attribute State_0 related method
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_State_0(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_State_0(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_State_0) ENABLED START -----*/

	*attr_State_0_read = channel_0->get_state();

	attr.set_value(attr_State_0_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_State_0
}
//--------------------------------------------------------
/**
 *	Read attribute State_1 related method
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_State_1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_State_1(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_State_1) ENABLED START -----*/

	*attr_State_1_read = channel_1->get_state();

	attr.set_value(attr_State_1_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_State_1
}
//--------------------------------------------------------
/**
 *	Read attribute State_2 related method
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_State_2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_State_2(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_State_2) ENABLED START -----*/

	*attr_State_2_read = channel_2->get_state();

	attr.set_value(attr_State_2_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_State_2
}
//--------------------------------------------------------
/**
 *	Read attribute State_3 related method
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_State_3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_State_3(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_State_3) ENABLED START -----*/

	*attr_State_3_read = channel_3->get_state();

	attr.set_value(attr_State_3_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_State_3
}
//--------------------------------------------------------
/**
 *	Read attribute Status_0 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Status_0(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Status_0(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Status_0) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Status_0_read, channel_0->get_status());

	attr.set_value(attr_Status_0_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Status_0
}
//--------------------------------------------------------
/**
 *	Read attribute Status_1 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Status_1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Status_1(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Status_1) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Status_1_read, channel_1->get_status());

	attr.set_value(attr_Status_1_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Status_1
}
//--------------------------------------------------------
/**
 *	Read attribute Status_2 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Status_2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Status_2(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Status_2) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Status_2_read, channel_2->get_status());

	attr.set_value(attr_Status_2_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Status_2
}
//--------------------------------------------------------
/**
 *	Read attribute Status_3 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Status_3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Status_3(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Status_3) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Status_3_read, channel_3->get_status());

	attr.set_value(attr_Status_3_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Status_3
}
//--------------------------------------------------------
/**
 *	Read attribute Name_0 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Name_0(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Name_0(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Name_0) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Name_0_read, channel_0->get_name());

	attr.set_value(attr_Name_0_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Name_0
}
//--------------------------------------------------------
/**
 *	Read attribute Name_1 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Name_1(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Name_1(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Name_1) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Name_1_read, channel_1->get_name());

	attr.set_value(attr_Name_1_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Name_1
}
//--------------------------------------------------------
/**
 *	Read attribute Name_2 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Name_2(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Name_2(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Name_2) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Name_2_read, channel_2->get_name());

	attr.set_value(attr_Name_2_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Name_2
}
//--------------------------------------------------------
/**
 *	Read attribute Name_3 related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_Name_3(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_Name_3(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_Name_3) ENABLED START -----*/

	Tpg300Utils::string_copy(attr_Name_3_read, channel_3->get_name());

	attr.set_value(attr_Name_3_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_Name_3
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceState related method
 *
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_DeviceState(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_DeviceState(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_DeviceState) ENABLED START -----*/

	//	Set the attribute value
	attr.set_value(attr_DeviceState_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_DeviceState
}
//--------------------------------------------------------
/**
 *	Write attribute DeviceState related method
 *
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::write_DeviceState(Tango::WAttribute &attr)
{
	DEBUG_STREAM << "Tpg300::write_DeviceState(Tango::WAttribute &attr) entering... " << std::endl;
	//	Retrieve write value
	Tango::DevUChar	w_val;
	attr.get_write_value(w_val);
	/*----- PROTECTED REGION ID(Tpg300::write_DeviceState) ENABLED START -----*/

	if (w_val >= DEVICESTATE_T_SIZE) {
    Tango::Except::throw_exception("", "Value out of range", \
                                   "MksSrg::write_DeviceState()");
  }
  *attr_DeviceState_read = w_val;

	/*----- PROTECTED REGION END -----*/	//	Tpg300::write_DeviceState
}
//--------------------------------------------------------
/**
 *	Read attribute DeviceStatus related method
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
//--------------------------------------------------------
void Tpg300::read_DeviceStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_DeviceStatus(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_DeviceStatus) ENABLED START -----*/

	//	Set the attribute value
	attr.set_value(attr_DeviceStatus_read);

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_DeviceStatus
}
//--------------------------------------------------------
/**
 *	Read attribute SetPointStatus related method
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Spectrum max = 6
 */
//--------------------------------------------------------
void Tpg300::read_SetPointStatus(Tango::Attribute &attr)
{
	DEBUG_STREAM << "Tpg300::read_SetPointStatus(Tango::Attribute &attr) entering... " << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_SetPointStatus) ENABLED START -----*/

	try
	{
		sp_manager->get_setpoint_value(attr_SetPointStatus_read, 6);

		attr.set_value(attr_SetPointStatus_read, 6);
	}
	catch(Tango::DevFailed &ex)
	{
		attr.set_quality(Tango::ATTR_INVALID, false);
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_SetPointStatus
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300::add_dynamic_attributes()
 *	Description: Create the dynamic attributes if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tpg300::add_dynamic_attributes()
{
	/*----- PROTECTED REGION ID(Tpg300::add_dynamic_attributes) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic attributes if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Tpg300::add_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Command SensorOn related method
 *	Description: Start measuring channel n
 *
 *	@param argin Channel
 *	[0,3]
 */
//--------------------------------------------------------
void Tpg300::sensor_on(Tango::DevShort argin)
{
	DEBUG_STREAM << "Tpg300::SensorOn()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::sensor_on) ENABLED START -----*/

	switch(argin)
	{
	case Tpg300Channel::CHANNEL_0:
		channel_0->on();
		break;
	case Tpg300Channel::CHANNEL_1:
		channel_1->on();
		break;
	case Tpg300Channel::CHANNEL_2:
		channel_2->on();
		break;
	case Tpg300Channel::CHANNEL_3:
		channel_3->on();
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-3]", "SensorOn");
		break;
	}
	/*----- PROTECTED REGION END -----*/	//	Tpg300::sensor_on
}
//--------------------------------------------------------
/**
 *	Command SensorOff related method
 *	Description: Stop measuring channel n
 *
 *	@param argin Channel
 *	[0,3]
 */
//--------------------------------------------------------
void Tpg300::sensor_off(Tango::DevShort argin)
{
	DEBUG_STREAM << "Tpg300::SensorOff()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::sensor_off) ENABLED START -----*/

	switch(argin)
	{
	case Tpg300Channel::CHANNEL_0:
		channel_0->off();
		break;
	case Tpg300Channel::CHANNEL_1:
		channel_1->off();
		break;
	case Tpg300Channel::CHANNEL_2:
		channel_2->off();
		break;
	case Tpg300Channel::CHANNEL_3:
		channel_3->off();
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-3]", "SensorOff");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::sensor_off
}
//--------------------------------------------------------
/**
 *	Command WriteLowerThreshold related method
 *	Description: Set setpoint lower threshold
 *
 *	@param argin Setpoint, Pressure
 *	
 *	Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	
 *	Pressure
 *	[1.0E-11, 9.9E+3]
 */
//--------------------------------------------------------
void Tpg300::write_lower_threshold(const Tango::DevVarDoubleArray *argin)
{
	DEBUG_STREAM << "Tpg300::WriteLowerThreshold()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::write_lower_threshold) ENABLED START -----*/

	//	Add your own code
	if(argin->length() != 2)
		Tango::Except::throw_exception("", "Invalid argument size, valid 2", "WriteLowerThreahold");
	if((*argin)[1] < 1.0E-11 || (*argin)[1] > 9.9E+3)
		Tango::Except::throw_exception("", "Out of range[1.0E-11, 9.9E+3]" , "WriteLowerThreahold");
	switch(int((*argin)[0]))
	{
	case 0:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_0, (*argin)[1]);
		break;
	case 1:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_1, (*argin)[1]);
		break;
	case 2:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_2, (*argin)[1]);
		break;
	case 3:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_3, (*argin)[1]);
		break;
	case 4:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_A, (*argin)[1]);
		break;
	case 5:
		sp_manager->set_lower_threshold(Tpg300SPManager::SETPOINT_B, (*argin)[1]);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "WriteLowerThreahold");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::write_lower_threshold
}
//--------------------------------------------------------
/**
 *	Command ReadLowerThreshold related method
 *	Description: Get setpoint lower threshold
 *
 *	@param argin Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	@returns Pressure
 */
//--------------------------------------------------------
Tango::DevDouble Tpg300::read_lower_threshold(Tango::DevShort argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "Tpg300::ReadLowerThreshold()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_lower_threshold) ENABLED START -----*/

	//	Add your own code
	switch(argin)
	{
	case 0:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_0);
		break;
	case 1:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_1);
		break;
	case 2:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_2);
		break;
	case 3:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_3);
		break;
	case 4:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_A);
		break;
	case 5:
		argout = sp_manager->get_lower_threshold(Tpg300SPManager::SETPOINT_B);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "ReadLowerThreahold");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_lower_threshold
	return argout;
}
//--------------------------------------------------------
/**
 *	Command WriteUpperThreshold related method
 *	Description: Set setpoint upper threshold
 *
 *	@param argin Setpoint, Pressure
 *	
 *	Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	
 *	Pressure
 *	[1.0E-11, 9.9E+3]
 */
//--------------------------------------------------------
void Tpg300::write_upper_threshold(const Tango::DevVarDoubleArray *argin)
{
	DEBUG_STREAM << "Tpg300::WriteUpperThreshold()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::write_upper_threshold) ENABLED START -----*/

	//	Add your own code
	if(argin->length() != 2)
		Tango::Except::throw_exception("", "Invalid argument size, valid 2", "WriteUpperThreahold");
	if((*argin)[1] < 1.0E-11 || (*argin)[1] > 9.9E+3)
		Tango::Except::throw_exception("", "Out of range[1.0E-11, 9.9E+3]" , "WriteUpperThreahold");
	switch(int((*argin)[0]))
	{
	case 0:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_0, (*argin)[1]);
		break;
	case 1:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_1, (*argin)[1]);
		break;
	case 2:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_2, (*argin)[1]);
		break;
	case 3:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_3, (*argin)[1]);
		break;
	case 4:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_A, (*argin)[1]);
		break;
	case 5:
		sp_manager->set_upper_threshold(Tpg300SPManager::SETPOINT_B, (*argin)[1]);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "WriteUpperThreahold");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::write_upper_threshold
}
//--------------------------------------------------------
/**
 *	Command ReadUpperThreshold related method
 *	Description: Get setpoint upper threshold
 *
 *	@param argin Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	@returns Pressure
 */
//--------------------------------------------------------
Tango::DevDouble Tpg300::read_upper_threshold(Tango::DevShort argin)
{
	Tango::DevDouble argout;
	DEBUG_STREAM << "Tpg300::ReadUpperThreshold()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_upper_threshold) ENABLED START -----*/

	//	Add your own code
	switch(argin)
	{
	case 0:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_0);
		break;
	case 1:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_1);
		break;
	case 2:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_2);
		break;
	case 3:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_3);
		break;
	case 4:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_A);
		break;
	case 5:
		argout = sp_manager->get_upper_threshold(Tpg300SPManager::SETPOINT_B);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "ReadLowerThreahold");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_upper_threshold
	return argout;
}
//--------------------------------------------------------
/**
 *	Command ReadSensorSource related method
 *	Description: Get setpoint source
 *
 *	@param argin Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	@returns Source
 *	0 -> No assignment
 *	1 -> Measuring circuit A1
 *	2 -> Measuring circuit A2
 *	3 -> Measuring circuit B1
 *	4 -> Measuring circuit B2
 *	5 -> Measuring circuit A1 (for self monitoring)
 *	6 -> Measuring circuit A2 (for self monitoring)
 *	7 -> Measuring circuit B1 (for self monitoring)
 *	8 -> Measuring circuit B2 (for self monitoring)
 */
//--------------------------------------------------------
Tango::DevShort Tpg300::read_sensor_source(Tango::DevShort argin)
{
	Tango::DevShort argout;
	DEBUG_STREAM << "Tpg300::ReadSensorSource()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::read_sensor_source) ENABLED START -----*/

	switch(argin)
	{
	case 0:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_0);
		break;
	case 1:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_1);
		break;
	case 2:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_2);
		break;
	case 3:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_3);
		break;
	case 4:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_A);
		break;
	case 5:
		argout = sp_manager->get_source(Tpg300SPManager::SETPOINT_B);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "ReadSensorSource");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::read_sensor_source
	return argout;
}
//--------------------------------------------------------
/**
 *	Command WriteSensorSource related method
 *	Description: Set setpoint switching function
 *
 *	@param argin Setpoint, Source
 *	
 *	Setpoint
 *	0 -> Switching function 1
 *	1 -> Switching function 2
 *	2 -> Switching function 3
 *	3 -> Switching function 4
 *	4 -> Switching function A
 *	5 -> Switching function B
 *	
 *	Source:
 *	0 -> No assignment
 *	1 -> Measuring circuit A1
 *	2 -> Measuring circuit A2
 *	3 -> Measuring circuit B1
 *	4 -> Measuring circuit B2
 *	5 -> Measuring circuit A1 (for self monitoring)
 *	6 -> Measuring circuit A2 (for self monitoring)
 *	7 -> Measuring circuit B1 (for self monitoring)
 *	8 -> Measuring circuit B2 (for self monitoring)
 */
//--------------------------------------------------------
void Tpg300::write_sensor_source(const Tango::DevVarShortArray *argin)
{
	DEBUG_STREAM << "Tpg300::WriteSensorSource()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::write_sensor_source) ENABLED START -----*/

	if(argin->length() != 2)
		Tango::Except::throw_exception("", "Invalid argument size, valid 2", "WriteSensorSource");

	if((*argin)[1] < 0 || (*argin)[1] > 8)
		Tango::Except::throw_exception("", "Out of range[0, 8]" , "WriteSensorSource");

	switch(int((*argin)[0]))
	{
	case 0:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_0, (*argin)[1]);
		break;
	case 1:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_1, (*argin)[1]);
		break;
	case 2:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_2, (*argin)[1]);
		break;
	case 3:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_3, (*argin)[1]);
		break;
	case 4:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_A, (*argin)[1]);
		break;
	case 5:
		sp_manager->set_source(Tpg300SPManager::SETPOINT_B, (*argin)[1]);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-5]", "WriteSensorSource");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::write_sensor_source
}
//--------------------------------------------------------
/**
 *	Command RegisterName related method
 *	Description: Set channel name
 *
 *	@param argin Channel, Name
 *	
 *	Channel
 *	[0,3]
 *	
 *	Name
 *	max 64 characters
 */
//--------------------------------------------------------
void Tpg300::register_name(const Tango::DevVarLongStringArray *argin)
{
	DEBUG_STREAM << "Tpg300::RegisterName()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::register_name) ENABLED START -----*/

	if(argin->lvalue.length() != 1 || argin->svalue.length() != 1)
		Tango::Except::throw_exception("", "Invalid argument size, valid 2", "RegisterName");

	long channel = argin->lvalue[0];
	string channel_name(argin->svalue[0]);

	if(channel_name.empty() || channel_name.size() > 64)
		Tango::Except::throw_exception("", "Invalid name size, min = 1, max = 64", "RegisterName");

	switch(channel)
	{
	case Tpg300Channel::CHANNEL_0:
		channel_0->set_name(channel_name);
		break;
	case Tpg300Channel::CHANNEL_1:
		channel_1->set_name(channel_name);
		break;
	case Tpg300Channel::CHANNEL_2:
		channel_2->set_name(channel_name);
		break;
	case Tpg300Channel::CHANNEL_3:
		channel_3->set_name(channel_name);
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-3]", "RegisterName");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::register_name
}
//--------------------------------------------------------
/**
 *	Command UnregisterName related method
 *	Description: Unregister channel name
 *
 *	@param argin Channel
 *	[0,3]
 */
//--------------------------------------------------------
void Tpg300::unregister_name(Tango::DevShort argin)
{
	DEBUG_STREAM << "Tpg300::UnregisterName()  - " << device_name << std::endl;
	/*----- PROTECTED REGION ID(Tpg300::unregister_name) ENABLED START -----*/

	switch(argin)
	{
	case Tpg300Channel::CHANNEL_0:
		channel_0->set_name("Unknown channel name");
		break;
	case Tpg300Channel::CHANNEL_1:
		channel_1->set_name("Unknown channel name");
		break;
	case Tpg300Channel::CHANNEL_2:
		channel_2->set_name("Unknown channel name");
		break;
	case Tpg300Channel::CHANNEL_3:
		channel_3->set_name("Unknown channel name");
		break;
	default:
		Tango::Except::throw_exception("", "Invalid argument, valid [0-3]", "RegisterName");
		break;
	}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::unregister_name
}
//--------------------------------------------------------
/**
 *	Method     : Tpg300::add_dynamic_commands()
 *	Description: Create the dynamic commands if any
 *                for specified device.
 */
//--------------------------------------------------------
void Tpg300::add_dynamic_commands()
{
	/*----- PROTECTED REGION ID(Tpg300::add_dynamic_commands) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code to create and add dynamic commands if any
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Tpg300::add_dynamic_commands
}

/*----- PROTECTED REGION ID(Tpg300::namespace_ending) ENABLED START -----*/

//========================================================
//	Utilities methods
//========================================================

//--------------------------------------------------------
/**
 *	Execute the update_state command:
 *	Description:
 */
//--------------------------------------------------------
void Tpg300::update_state()
{
	DEBUG_STREAM << "Tpg300::update_state()  - " << device_name << endl;

	Tango::DevState tpg_state = Tango::UNKNOWN;

	tpg_state = error_status->get_state();

	if(channel_0->get_state() == Tango::FAULT ||
			channel_1->get_state() == Tango::FAULT ||
			channel_2->get_state() == Tango::FAULT ||
			channel_3->get_state() == Tango::FAULT)
		tpg_state = Tango::FAULT;

	set_state(tpg_state);
}

//--------------------------------------------------------
/**
 *	Execute the update_status command:
 *	Description:
 */
//--------------------------------------------------------
void Tpg300::update_status()
{
	DEBUG_STREAM << "Tpg300::update_status()  - " << device_name << endl;

	stringstream status_str;

	if(error_status->get_state() == Tango::ALARM ||
			error_status->get_state() == Tango::FAULT)
		status_str << error_status->get_status() << endl;

	if(channel_0->get_state() == Tango::FAULT)
		status_str << channel_0->get_status() << endl;

	if(channel_1->get_state() == Tango::FAULT)
		status_str << channel_1->get_status() << endl;

	if(channel_2->get_state() == Tango::FAULT)
		status_str << channel_2->get_status() << endl;

	if(channel_3->get_state() == Tango::FAULT)
		status_str << channel_3->get_status() << endl;

	if(status_str.str().empty())
		status_str << "Connected to " << serialDevice << endl;

	set_status(status_str.str());
}

	/*----- PROTECTED REGION END -----*/	//	Tpg300::namespace_ending
} //	namespace
