/*----- PROTECTED REGION ID(Tpg300.h) ENABLED START -----*/
//=============================================================================
//
// file :        Tpg300.h
//
// description : Include for the Tpg300 class.
//
// project :     Blzer Tpg 300.
//
// $Author: claudio $
//
// $Revision: 1.7 $
// $Date: 2016-10-18 15:53:02 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/tpg300/src/Tpg300.h,v $
// $Log: Tpg300.h,v $
// Revision 1.7  2016-10-18 15:53:02  claudio
// tango9
//
// Revision 1.6  2013-06-05 14:59:10  lorenzo
// Tango 8.0.5
//
// Revision 1.5  2012-09-10 08:01:04  mdm
// Bugfix in thread and on off commands
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef TPG300_H
#define TPG300_H


#include <tango.h>

/*----- PROTECTED REGION END -----*/	//	Tpg300.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  Tpg300 class description:
 *    Total pressure gauge and controller
 */


namespace Tpg300_ns
{
/*----- PROTECTED REGION ID(Tpg300::Additional Class Declarations) ENABLED START -----*/

class Tpg300Proxy;
class Tpg300Channel;
class Tpg300SPManager;
class Tpg300Error;
class Tpg300Thread;

	/*----- PROTECTED REGION END -----*/	//	Tpg300::Additional Class Declarations

class Tpg300 : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(Tpg300::Data Members) ENABLED START -----*/

	omni_mutex* stop_mutex;
	omni_condition* stop_condition;

	Tpg300Proxy* proxy;

	Tpg300Error* error_status;

	Tpg300SPManager* sp_manager;

	Tpg300Channel* channel_0;
	Tpg300Channel* channel_1;
	Tpg300Channel* channel_2;
	Tpg300Channel* channel_3;

	Tpg300Thread* thread;

	bool init_completed;

	/*----- PROTECTED REGION END -----*/	//	Tpg300::Data Members

//	Device property data members
public:
	//	SerialDevice:	
	std::string	serialDevice;
	//	Timeout:	Milliseconds
	Tango::DevULong	timeout;
	//	ThreadSleep:	Millisecond
	Tango::DevULong	threadSleep;
	//	ProxySleep:	Millisecond
	Tango::DevULong	proxySleep;

//	Attribute data members
public:
	Tango::DevDouble	*attr_Pressure_0_read;
	Tango::DevDouble	*attr_Pressure_1_read;
	Tango::DevDouble	*attr_Pressure_2_read;
	Tango::DevDouble	*attr_Pressure_3_read;
	Tango::DevState	*attr_State_0_read;
	Tango::DevState	*attr_State_1_read;
	Tango::DevState	*attr_State_2_read;
	Tango::DevState	*attr_State_3_read;
	Tango::DevString	*attr_Status_0_read;
	Tango::DevString	*attr_Status_1_read;
	Tango::DevString	*attr_Status_2_read;
	Tango::DevString	*attr_Status_3_read;
	Tango::DevString	*attr_Name_0_read;
	Tango::DevString	*attr_Name_1_read;
	Tango::DevString	*attr_Name_2_read;
	Tango::DevString	*attr_Name_3_read;
	Tango::DevUChar	*attr_DeviceState_read;
	Tango::DevString	*attr_DeviceStatus_read;
	Tango::DevBoolean	*attr_SetPointStatus_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tpg300(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Tpg300(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Tpg300(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~Tpg300();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : Tpg300::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method     : Tpg300::write_attr_hardware()
	 *	Description: Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute Pressure_0 related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Pressure_0(Tango::Attribute &attr);
	virtual bool is_Pressure_0_allowed(Tango::AttReqType type);
/**
 *	Attribute Pressure_1 related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Pressure_1(Tango::Attribute &attr);
	virtual bool is_Pressure_1_allowed(Tango::AttReqType type);
/**
 *	Attribute Pressure_2 related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Pressure_2(Tango::Attribute &attr);
	virtual bool is_Pressure_2_allowed(Tango::AttReqType type);
/**
 *	Attribute Pressure_3 related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Pressure_3(Tango::Attribute &attr);
	virtual bool is_Pressure_3_allowed(Tango::AttReqType type);
/**
 *	Attribute State_0 related methods
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
	virtual void read_State_0(Tango::Attribute &attr);
	virtual bool is_State_0_allowed(Tango::AttReqType type);
/**
 *	Attribute State_1 related methods
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
	virtual void read_State_1(Tango::Attribute &attr);
	virtual bool is_State_1_allowed(Tango::AttReqType type);
/**
 *	Attribute State_2 related methods
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
	virtual void read_State_2(Tango::Attribute &attr);
	virtual bool is_State_2_allowed(Tango::AttReqType type);
/**
 *	Attribute State_3 related methods
 *
 *
 *	Data type:	Tango::DevState
 *	Attr type:	Scalar
 */
	virtual void read_State_3(Tango::Attribute &attr);
	virtual bool is_State_3_allowed(Tango::AttReqType type);
/**
 *	Attribute Status_0 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Status_0(Tango::Attribute &attr);
	virtual bool is_Status_0_allowed(Tango::AttReqType type);
/**
 *	Attribute Status_1 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Status_1(Tango::Attribute &attr);
	virtual bool is_Status_1_allowed(Tango::AttReqType type);
/**
 *	Attribute Status_2 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Status_2(Tango::Attribute &attr);
	virtual bool is_Status_2_allowed(Tango::AttReqType type);
/**
 *	Attribute Status_3 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Status_3(Tango::Attribute &attr);
	virtual bool is_Status_3_allowed(Tango::AttReqType type);
/**
 *	Attribute Name_0 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Name_0(Tango::Attribute &attr);
	virtual bool is_Name_0_allowed(Tango::AttReqType type);
/**
 *	Attribute Name_1 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Name_1(Tango::Attribute &attr);
	virtual bool is_Name_1_allowed(Tango::AttReqType type);
/**
 *	Attribute Name_2 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Name_2(Tango::Attribute &attr);
	virtual bool is_Name_2_allowed(Tango::AttReqType type);
/**
 *	Attribute Name_3 related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Name_3(Tango::Attribute &attr);
	virtual bool is_Name_3_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceState related methods
 *
 *
 *	Data type:	Tango::DevUChar
 *	Attr type:	Scalar
 */
	virtual void read_DeviceState(Tango::Attribute &attr);
	virtual void write_DeviceState(Tango::WAttribute &attr);
	virtual bool is_DeviceState_allowed(Tango::AttReqType type);
/**
 *	Attribute DeviceStatus related methods
 *
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_DeviceStatus(Tango::Attribute &attr);
	virtual bool is_DeviceStatus_allowed(Tango::AttReqType type);
/**
 *	Attribute SetPointStatus related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Spectrum max = 6
 */
	virtual void read_SetPointStatus(Tango::Attribute &attr);
	virtual bool is_SetPointStatus_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : Tpg300::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command SensorOn related method
	 *	Description: Start measuring channel n
	 *
	 *	@param argin Channel
	 *	[0,3]
	 */
	virtual void sensor_on(Tango::DevShort argin);
	virtual bool is_SensorOn_allowed(const CORBA::Any &any);
	/**
	 *	Command SensorOff related method
	 *	Description: Stop measuring channel n
	 *
	 *	@param argin Channel
	 *	[0,3]
	 */
	virtual void sensor_off(Tango::DevShort argin);
	virtual bool is_SensorOff_allowed(const CORBA::Any &any);
	/**
	 *	Command WriteLowerThreshold related method
	 *	Description: Set setpoint lower threshold
	 *
	 *	@param argin Setpoint, Pressure
	 *	
	 *	Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	
	 *	Pressure
	 *	[1.0E-11, 9.9E+3]
	 */
	virtual void write_lower_threshold(const Tango::DevVarDoubleArray *argin);
	virtual bool is_WriteLowerThreshold_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadLowerThreshold related method
	 *	Description: Get setpoint lower threshold
	 *
	 *	@param argin Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	@returns Pressure
	 */
	virtual Tango::DevDouble read_lower_threshold(Tango::DevShort argin);
	virtual bool is_ReadLowerThreshold_allowed(const CORBA::Any &any);
	/**
	 *	Command WriteUpperThreshold related method
	 *	Description: Set setpoint upper threshold
	 *
	 *	@param argin Setpoint, Pressure
	 *	
	 *	Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	
	 *	Pressure
	 *	[1.0E-11, 9.9E+3]
	 */
	virtual void write_upper_threshold(const Tango::DevVarDoubleArray *argin);
	virtual bool is_WriteUpperThreshold_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadUpperThreshold related method
	 *	Description: Get setpoint upper threshold
	 *
	 *	@param argin Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	@returns Pressure
	 */
	virtual Tango::DevDouble read_upper_threshold(Tango::DevShort argin);
	virtual bool is_ReadUpperThreshold_allowed(const CORBA::Any &any);
	/**
	 *	Command ReadSensorSource related method
	 *	Description: Get setpoint source
	 *
	 *	@param argin Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	@returns Source
	 *	0 -> No assignment
	 *	1 -> Measuring circuit A1
	 *	2 -> Measuring circuit A2
	 *	3 -> Measuring circuit B1
	 *	4 -> Measuring circuit B2
	 *	5 -> Measuring circuit A1 (for self monitoring)
	 *	6 -> Measuring circuit A2 (for self monitoring)
	 *	7 -> Measuring circuit B1 (for self monitoring)
	 *	8 -> Measuring circuit B2 (for self monitoring)
	 */
	virtual Tango::DevShort read_sensor_source(Tango::DevShort argin);
	virtual bool is_ReadSensorSource_allowed(const CORBA::Any &any);
	/**
	 *	Command WriteSensorSource related method
	 *	Description: Set setpoint switching function
	 *
	 *	@param argin Setpoint, Source
	 *	
	 *	Setpoint
	 *	0 -> Switching function 1
	 *	1 -> Switching function 2
	 *	2 -> Switching function 3
	 *	3 -> Switching function 4
	 *	4 -> Switching function A
	 *	5 -> Switching function B
	 *	
	 *	Source:
	 *	0 -> No assignment
	 *	1 -> Measuring circuit A1
	 *	2 -> Measuring circuit A2
	 *	3 -> Measuring circuit B1
	 *	4 -> Measuring circuit B2
	 *	5 -> Measuring circuit A1 (for self monitoring)
	 *	6 -> Measuring circuit A2 (for self monitoring)
	 *	7 -> Measuring circuit B1 (for self monitoring)
	 *	8 -> Measuring circuit B2 (for self monitoring)
	 */
	virtual void write_sensor_source(const Tango::DevVarShortArray *argin);
	virtual bool is_WriteSensorSource_allowed(const CORBA::Any &any);
	/**
	 *	Command RegisterName related method
	 *	Description: Set channel name
	 *
	 *	@param argin Channel, Name
	 *	
	 *	Channel
	 *	[0,3]
	 *	
	 *	Name
	 *	max 64 characters
	 */
	virtual void register_name(const Tango::DevVarLongStringArray *argin);
	virtual bool is_RegisterName_allowed(const CORBA::Any &any);
	/**
	 *	Command UnregisterName related method
	 *	Description: Unregister channel name
	 *
	 *	@param argin Channel
	 *	[0,3]
	 */
	virtual void unregister_name(Tango::DevShort argin);
	virtual bool is_UnregisterName_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : Tpg300::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Tpg300::Additional Method prototypes) ENABLED START -----*/

	void update_state();

	void update_status();

	/*----- PROTECTED REGION END -----*/	//	Tpg300::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Tpg300::Additional Classes Definitions) ENABLED START -----*/

	//	Additional Classes definitions

	/*----- PROTECTED REGION END -----*/	//	Tpg300::Additional Classes Definitions

}	//	End of namespace

#endif   //	Tpg300_H
