/*
 * Tpg300Channel.h
 *
 *  Created on: Jun 12, 2012
 *      Author: mdm
 */

#ifndef TPG300CHANNEL_H_
#define TPG300CHANNEL_H_

#include <tango.h>
#include <Tpg300Task.h>

namespace Tpg300_ns
{

class Tpg300Proxy;

class Tpg300Channel : public Tpg300Task
{

public:
	enum Channel{CHANNEL_0 = 0, CHANNEL_1 = 1, CHANNEL_2 = 2, CHANNEL_3 = 3};
	enum ChannelState{OFF = 1, ON = 3};

public:
	Tpg300Channel(Tpg300Proxy*, Channel);
	virtual ~Tpg300Channel() {};

public:
	virtual void update();
	virtual Tango::DevDouble get_pressure();
	virtual Tango::DevState get_state();
	virtual std::string get_status();
	virtual void set_name(std::string);
	virtual std::string get_name();
	virtual void on();
	virtual void off();

protected:
	virtual void read_write_state(Channel, ChannelState);
	virtual Tango::DevDouble parse_pressure(std::string);
	virtual Tango::DevState parse_state(std::string);
	virtual std::string parse_status(std::string);

private:
    Tango::DevDouble pressure;
    Tango::DevState state;
    std::string status;
    std::string name;
    Tpg300Proxy* proxy;
    omni_mutex mutex;
    const Channel channel;
};

}

#endif /* TPG300CHANNEL_H_ */
