/*----- PROTECTED REGION ID(Tpg300Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id: Tpg300Class.cpp,v 1.6 2013-06-05 14:59:10 lorenzo Exp $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source: /home/cvsadm/cvsroot/fermi/servers/tpg300/src/Tpg300Class.cpp,v $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        Tpg300Class.cpp
//
// description : C++ source for the Tpg300Class. A singleton
//               class derived from DeviceClass. It implements the
//               command list and all properties and methods required
//               by the �name� once per process.
//
// project :     Blzer Tpg 300.
//
// $Author: lorenzo $
//
// $Revision: 1.6 $
// $Date: 2013-06-05 14:59:10 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/tpg300/src/Tpg300Class.cpp,v $
// $Log: Tpg300Class.cpp,v $
// Revision 1.6  2013-06-05 14:59:10  lorenzo
// Tango 8.0.5
//
// Revision 1.5  2012-09-10 08:01:04  mdm
// Bugfix in thread and on off commands
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <Tpg300Class.h>

/*----- PROTECTED REGION END -----*/	//	Tpg300Class.cpp

//-------------------------------------------------------------------
/**
 *	Create Tpg300Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_Tpg300_class(const char *name) {
		return Tpg300_ns::Tpg300Class::init(name);
	}
}

namespace Tpg300_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
Tpg300Class *Tpg300Class::_instance = NULL;

//===================================================================
//	Class constants
//===================================================================
const long SetPointStatusAttrib::X_DATA_SIZE;
//--------------------------------------------------------
/**
 * method : 		Tpg300Class::Tpg300Class(std::string &s)
 * description : 	constructor for the Tpg300Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
Tpg300Class::Tpg300Class(std::string &s):Tango::DeviceClass(s)
{
	TANGO_LOG_INFO << "Entering Tpg300Class constructor" << std::endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(Tpg300Class::constructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::constructor

	TANGO_LOG_INFO << "Leaving Tpg300Class constructor" << std::endl;
}

//--------------------------------------------------------
/**
 * method : 		Tpg300Class::~Tpg300Class()
 * description : 	destructor for the Tpg300Class
 */
//--------------------------------------------------------
Tpg300Class::~Tpg300Class()
{
	/*----- PROTECTED REGION ID(Tpg300Class::destructor) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		Tpg300Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
Tpg300Class *Tpg300Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			std::string s(name);
			_instance = new Tpg300Class(s);
		}
		catch (std::bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		Tpg300Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
Tpg300Class *Tpg300Class::instance()
{
	if (_instance == NULL)
	{
		std::cerr << "Class is not initialized !!" << std::endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		SensorOnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SensorOnClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SensorOnClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->sensor_on(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		SensorOffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *SensorOffClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "SensorOffClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->sensor_off(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		WriteLowerThresholdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *WriteLowerThresholdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "WriteLowerThresholdClass::execute(): arrived" << std::endl;
	const Tango::DevVarDoubleArray *argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->write_lower_threshold(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ReadLowerThresholdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadLowerThresholdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ReadLowerThresholdClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	return insert((static_cast<Tpg300 *>(device))->read_lower_threshold(argin));
}

//--------------------------------------------------------
/**
 * method : 		WriteUpperThresholdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *WriteUpperThresholdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "WriteUpperThresholdClass::execute(): arrived" << std::endl;
	const Tango::DevVarDoubleArray *argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->write_upper_threshold(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ReadUpperThresholdClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadUpperThresholdClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ReadUpperThresholdClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	return insert((static_cast<Tpg300 *>(device))->read_upper_threshold(argin));
}

//--------------------------------------------------------
/**
 * method : 		ReadSensorSourceClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ReadSensorSourceClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "ReadSensorSourceClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	return insert((static_cast<Tpg300 *>(device))->read_sensor_source(argin));
}

//--------------------------------------------------------
/**
 * method : 		WriteSensorSourceClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *WriteSensorSourceClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "WriteSensorSourceClass::execute(): arrived" << std::endl;
	const Tango::DevVarShortArray *argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->write_sensor_source(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		RegisterNameClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *RegisterNameClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "RegisterNameClass::execute(): arrived" << std::endl;
	const Tango::DevVarLongStringArray *argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->register_name(argin));
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		UnregisterNameClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *UnregisterNameClass::execute(Tango::DeviceImpl *device, const CORBA::Any &in_any)
{
	TANGO_LOG_INFO << "UnregisterNameClass::execute(): arrived" << std::endl;
	Tango::DevShort argin;
	extract(in_any, argin);
	((static_cast<Tpg300 *>(device))->unregister_name(argin));
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::get_class_property()
 *	Description: Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum Tpg300Class::get_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::get_default_device_property()
 *	Description: Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum Tpg300Class::get_default_device_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::get_default_class_property()
 *	Description: Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum Tpg300Class::get_default_class_property(std::string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::set_default_property()
 *	Description: Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void Tpg300Class::set_default_property()
{
	std::string	prop_name;
	std::string	prop_desc;
	std::string	prop_def;
	std::vector<std::string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "SerialDevice";
	prop_desc = "";
	prop_def  = "undefined";
	vect_data.clear();
	vect_data.push_back("undefined");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Timeout";
	prop_desc = "Milliseconds";
	prop_def  = "2500";
	vect_data.clear();
	vect_data.push_back("2500");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ThreadSleep";
	prop_desc = "Millisecond";
	prop_def  = "1500";
	vect_data.clear();
	vect_data.push_back("1500");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "ProxySleep";
	prop_desc = "Millisecond";
	prop_def  = "1500";
	vect_data.clear();
	vect_data.push_back("1500");
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::write_class_property()
 *	Description: Set class description fields as property in database
 */
//--------------------------------------------------------
void Tpg300Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	std::string	classname = get_name();
	std::string	header;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	std::string	str_title("Blzer Tpg 300");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	std::vector<std::string>	str_desc;
	str_desc.push_back("Total pressure gauge and controller");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	std::vector<std::string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::device_factory()
 *	Description: Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void Tpg300Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(Tpg300Class::device_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		TANGO_LOG_DEBUG << "Device name : " << (*devlist_ptr)[i].in() << std::endl;
		device_list.push_back(new Tpg300(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		Tpg300 *dev = static_cast<Tpg300 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(Tpg300Class::device_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::attribute_factory()
 *	Description: Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void Tpg300Class::attribute_factory(std::vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(Tpg300Class::attribute_factory_before) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::attribute_factory_before
	//	Attribute : Pressure_0
	Pressure_0Attrib	*pressure_0 = new Pressure_0Attrib();
	Tango::UserDefaultAttrProp	pressure_0_prop;
	//	description	not set for Pressure_0
	//	label	not set for Pressure_0
	pressure_0_prop.set_unit("mbar");
	pressure_0_prop.set_standard_unit("mbar");
	pressure_0_prop.set_display_unit("mbar");
	//	format	not set for Pressure_0
	//	max_value	not set for Pressure_0
	//	min_value	not set for Pressure_0
	//	max_alarm	not set for Pressure_0
	//	min_alarm	not set for Pressure_0
	//	max_warning	not set for Pressure_0
	//	min_warning	not set for Pressure_0
	//	delta_t	not set for Pressure_0
	//	delta_val	not set for Pressure_0
	pressure_0->set_default_properties(pressure_0_prop);
	//	Not Polled
	pressure_0->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pressure_0);

	//	Attribute : Pressure_1
	Pressure_1Attrib	*pressure_1 = new Pressure_1Attrib();
	Tango::UserDefaultAttrProp	pressure_1_prop;
	//	description	not set for Pressure_1
	//	label	not set for Pressure_1
	pressure_1_prop.set_unit("mbar");
	pressure_1_prop.set_standard_unit("mbar");
	pressure_1_prop.set_display_unit("mbar");
	//	format	not set for Pressure_1
	//	max_value	not set for Pressure_1
	//	min_value	not set for Pressure_1
	//	max_alarm	not set for Pressure_1
	//	min_alarm	not set for Pressure_1
	//	max_warning	not set for Pressure_1
	//	min_warning	not set for Pressure_1
	//	delta_t	not set for Pressure_1
	//	delta_val	not set for Pressure_1
	pressure_1->set_default_properties(pressure_1_prop);
	//	Not Polled
	pressure_1->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pressure_1);

	//	Attribute : Pressure_2
	Pressure_2Attrib	*pressure_2 = new Pressure_2Attrib();
	Tango::UserDefaultAttrProp	pressure_2_prop;
	//	description	not set for Pressure_2
	//	label	not set for Pressure_2
	pressure_2_prop.set_unit("mbar");
	pressure_2_prop.set_standard_unit("mbar");
	pressure_2_prop.set_display_unit("mbar");
	//	format	not set for Pressure_2
	//	max_value	not set for Pressure_2
	//	min_value	not set for Pressure_2
	//	max_alarm	not set for Pressure_2
	//	min_alarm	not set for Pressure_2
	//	max_warning	not set for Pressure_2
	//	min_warning	not set for Pressure_2
	//	delta_t	not set for Pressure_2
	//	delta_val	not set for Pressure_2
	pressure_2->set_default_properties(pressure_2_prop);
	//	Not Polled
	pressure_2->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pressure_2);

	//	Attribute : Pressure_3
	Pressure_3Attrib	*pressure_3 = new Pressure_3Attrib();
	Tango::UserDefaultAttrProp	pressure_3_prop;
	//	description	not set for Pressure_3
	//	label	not set for Pressure_3
	pressure_3_prop.set_unit("mbar");
	pressure_3_prop.set_standard_unit("mbar");
	pressure_3_prop.set_display_unit("mbar");
	//	format	not set for Pressure_3
	//	max_value	not set for Pressure_3
	//	min_value	not set for Pressure_3
	//	max_alarm	not set for Pressure_3
	//	min_alarm	not set for Pressure_3
	//	max_warning	not set for Pressure_3
	//	min_warning	not set for Pressure_3
	//	delta_t	not set for Pressure_3
	//	delta_val	not set for Pressure_3
	pressure_3->set_default_properties(pressure_3_prop);
	//	Not Polled
	pressure_3->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(pressure_3);

	//	Attribute : State_0
	State_0Attrib	*state_0 = new State_0Attrib();
	Tango::UserDefaultAttrProp	state_0_prop;
	//	description	not set for State_0
	//	label	not set for State_0
	//	unit	not set for State_0
	//	standard_unit	not set for State_0
	//	display_unit	not set for State_0
	//	format	not set for State_0
	//	max_value	not set for State_0
	//	min_value	not set for State_0
	//	max_alarm	not set for State_0
	//	min_alarm	not set for State_0
	//	max_warning	not set for State_0
	//	min_warning	not set for State_0
	//	delta_t	not set for State_0
	//	delta_val	not set for State_0
	state_0->set_default_properties(state_0_prop);
	//	Not Polled
	state_0->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(state_0);

	//	Attribute : State_1
	State_1Attrib	*state_1 = new State_1Attrib();
	Tango::UserDefaultAttrProp	state_1_prop;
	//	description	not set for State_1
	//	label	not set for State_1
	//	unit	not set for State_1
	//	standard_unit	not set for State_1
	//	display_unit	not set for State_1
	//	format	not set for State_1
	//	max_value	not set for State_1
	//	min_value	not set for State_1
	//	max_alarm	not set for State_1
	//	min_alarm	not set for State_1
	//	max_warning	not set for State_1
	//	min_warning	not set for State_1
	//	delta_t	not set for State_1
	//	delta_val	not set for State_1
	state_1->set_default_properties(state_1_prop);
	//	Not Polled
	state_1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(state_1);

	//	Attribute : State_2
	State_2Attrib	*state_2 = new State_2Attrib();
	Tango::UserDefaultAttrProp	state_2_prop;
	//	description	not set for State_2
	//	label	not set for State_2
	//	unit	not set for State_2
	//	standard_unit	not set for State_2
	//	display_unit	not set for State_2
	//	format	not set for State_2
	//	max_value	not set for State_2
	//	min_value	not set for State_2
	//	max_alarm	not set for State_2
	//	min_alarm	not set for State_2
	//	max_warning	not set for State_2
	//	min_warning	not set for State_2
	//	delta_t	not set for State_2
	//	delta_val	not set for State_2
	state_2->set_default_properties(state_2_prop);
	//	Not Polled
	state_2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(state_2);

	//	Attribute : State_3
	State_3Attrib	*state_3 = new State_3Attrib();
	Tango::UserDefaultAttrProp	state_3_prop;
	//	description	not set for State_3
	//	label	not set for State_3
	//	unit	not set for State_3
	//	standard_unit	not set for State_3
	//	display_unit	not set for State_3
	//	format	not set for State_3
	//	max_value	not set for State_3
	//	min_value	not set for State_3
	//	max_alarm	not set for State_3
	//	min_alarm	not set for State_3
	//	max_warning	not set for State_3
	//	min_warning	not set for State_3
	//	delta_t	not set for State_3
	//	delta_val	not set for State_3
	state_3->set_default_properties(state_3_prop);
	//	Not Polled
	state_3->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(state_3);

	//	Attribute : Status_0
	Status_0Attrib	*status_0 = new Status_0Attrib();
	Tango::UserDefaultAttrProp	status_0_prop;
	//	description	not set for Status_0
	//	label	not set for Status_0
	//	unit	not set for Status_0
	//	standard_unit	not set for Status_0
	//	display_unit	not set for Status_0
	//	format	not set for Status_0
	//	max_value	not set for Status_0
	//	min_value	not set for Status_0
	//	max_alarm	not set for Status_0
	//	min_alarm	not set for Status_0
	//	max_warning	not set for Status_0
	//	min_warning	not set for Status_0
	//	delta_t	not set for Status_0
	//	delta_val	not set for Status_0
	status_0->set_default_properties(status_0_prop);
	//	Not Polled
	status_0->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(status_0);

	//	Attribute : Status_1
	Status_1Attrib	*status_1 = new Status_1Attrib();
	Tango::UserDefaultAttrProp	status_1_prop;
	//	description	not set for Status_1
	//	label	not set for Status_1
	//	unit	not set for Status_1
	//	standard_unit	not set for Status_1
	//	display_unit	not set for Status_1
	//	format	not set for Status_1
	//	max_value	not set for Status_1
	//	min_value	not set for Status_1
	//	max_alarm	not set for Status_1
	//	min_alarm	not set for Status_1
	//	max_warning	not set for Status_1
	//	min_warning	not set for Status_1
	//	delta_t	not set for Status_1
	//	delta_val	not set for Status_1
	status_1->set_default_properties(status_1_prop);
	//	Not Polled
	status_1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(status_1);

	//	Attribute : Status_2
	Status_2Attrib	*status_2 = new Status_2Attrib();
	Tango::UserDefaultAttrProp	status_2_prop;
	//	description	not set for Status_2
	//	label	not set for Status_2
	//	unit	not set for Status_2
	//	standard_unit	not set for Status_2
	//	display_unit	not set for Status_2
	//	format	not set for Status_2
	//	max_value	not set for Status_2
	//	min_value	not set for Status_2
	//	max_alarm	not set for Status_2
	//	min_alarm	not set for Status_2
	//	max_warning	not set for Status_2
	//	min_warning	not set for Status_2
	//	delta_t	not set for Status_2
	//	delta_val	not set for Status_2
	status_2->set_default_properties(status_2_prop);
	//	Not Polled
	status_2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(status_2);

	//	Attribute : Status_3
	Status_3Attrib	*status_3 = new Status_3Attrib();
	Tango::UserDefaultAttrProp	status_3_prop;
	//	description	not set for Status_3
	//	label	not set for Status_3
	//	unit	not set for Status_3
	//	standard_unit	not set for Status_3
	//	display_unit	not set for Status_3
	//	format	not set for Status_3
	//	max_value	not set for Status_3
	//	min_value	not set for Status_3
	//	max_alarm	not set for Status_3
	//	min_alarm	not set for Status_3
	//	max_warning	not set for Status_3
	//	min_warning	not set for Status_3
	//	delta_t	not set for Status_3
	//	delta_val	not set for Status_3
	status_3->set_default_properties(status_3_prop);
	//	Not Polled
	status_3->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(status_3);

	//	Attribute : Name_0
	Name_0Attrib	*name_0 = new Name_0Attrib();
	Tango::UserDefaultAttrProp	name_0_prop;
	//	description	not set for Name_0
	//	label	not set for Name_0
	//	unit	not set for Name_0
	//	standard_unit	not set for Name_0
	//	display_unit	not set for Name_0
	//	format	not set for Name_0
	//	max_value	not set for Name_0
	//	min_value	not set for Name_0
	//	max_alarm	not set for Name_0
	//	min_alarm	not set for Name_0
	//	max_warning	not set for Name_0
	//	min_warning	not set for Name_0
	//	delta_t	not set for Name_0
	//	delta_val	not set for Name_0
	name_0->set_default_properties(name_0_prop);
	//	Not Polled
	name_0->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(name_0);

	//	Attribute : Name_1
	Name_1Attrib	*name_1 = new Name_1Attrib();
	Tango::UserDefaultAttrProp	name_1_prop;
	//	description	not set for Name_1
	//	label	not set for Name_1
	//	unit	not set for Name_1
	//	standard_unit	not set for Name_1
	//	display_unit	not set for Name_1
	//	format	not set for Name_1
	//	max_value	not set for Name_1
	//	min_value	not set for Name_1
	//	max_alarm	not set for Name_1
	//	min_alarm	not set for Name_1
	//	max_warning	not set for Name_1
	//	min_warning	not set for Name_1
	//	delta_t	not set for Name_1
	//	delta_val	not set for Name_1
	name_1->set_default_properties(name_1_prop);
	//	Not Polled
	name_1->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(name_1);

	//	Attribute : Name_2
	Name_2Attrib	*name_2 = new Name_2Attrib();
	Tango::UserDefaultAttrProp	name_2_prop;
	//	description	not set for Name_2
	//	label	not set for Name_2
	//	unit	not set for Name_2
	//	standard_unit	not set for Name_2
	//	display_unit	not set for Name_2
	//	format	not set for Name_2
	//	max_value	not set for Name_2
	//	min_value	not set for Name_2
	//	max_alarm	not set for Name_2
	//	min_alarm	not set for Name_2
	//	max_warning	not set for Name_2
	//	min_warning	not set for Name_2
	//	delta_t	not set for Name_2
	//	delta_val	not set for Name_2
	name_2->set_default_properties(name_2_prop);
	//	Not Polled
	name_2->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(name_2);

	//	Attribute : Name_3
	Name_3Attrib	*name_3 = new Name_3Attrib();
	Tango::UserDefaultAttrProp	name_3_prop;
	//	description	not set for Name_3
	//	label	not set for Name_3
	//	unit	not set for Name_3
	//	standard_unit	not set for Name_3
	//	display_unit	not set for Name_3
	//	format	not set for Name_3
	//	max_value	not set for Name_3
	//	min_value	not set for Name_3
	//	max_alarm	not set for Name_3
	//	min_alarm	not set for Name_3
	//	max_warning	not set for Name_3
	//	min_warning	not set for Name_3
	//	delta_t	not set for Name_3
	//	delta_val	not set for Name_3
	name_3->set_default_properties(name_3_prop);
	//	Not Polled
	name_3->set_disp_level(Tango::EXPERT);
	//	Not Memorized
	att_list.push_back(name_3);

	//	Attribute : DeviceState
	DeviceStateAttrib	*devicestate = new DeviceStateAttrib();
	Tango::UserDefaultAttrProp	devicestate_prop;
	//	description	not set for DeviceState
	//	label	not set for DeviceState
	//	unit	not set for DeviceState
	//	standard_unit	not set for DeviceState
	//	display_unit	not set for DeviceState
	//	format	not set for DeviceState
	//	max_value	not set for DeviceState
	//	min_value	not set for DeviceState
	//	max_alarm	not set for DeviceState
	//	min_alarm	not set for DeviceState
	//	max_warning	not set for DeviceState
	//	min_warning	not set for DeviceState
	//	delta_t	not set for DeviceState
	//	delta_val	not set for DeviceState
	devicestate->set_default_properties(devicestate_prop);
	//	Not Polled
	devicestate->set_disp_level(Tango::OPERATOR);
	devicestate->set_memorized();
	devicestate->set_memorized_init(false);
	att_list.push_back(devicestate);

	//	Attribute : DeviceStatus
	DeviceStatusAttrib	*devicestatus = new DeviceStatusAttrib();
	Tango::UserDefaultAttrProp	devicestatus_prop;
	//	description	not set for DeviceStatus
	//	label	not set for DeviceStatus
	//	unit	not set for DeviceStatus
	//	standard_unit	not set for DeviceStatus
	//	display_unit	not set for DeviceStatus
	//	format	not set for DeviceStatus
	//	max_value	not set for DeviceStatus
	//	min_value	not set for DeviceStatus
	//	max_alarm	not set for DeviceStatus
	//	min_alarm	not set for DeviceStatus
	//	max_warning	not set for DeviceStatus
	//	min_warning	not set for DeviceStatus
	//	delta_t	not set for DeviceStatus
	//	delta_val	not set for DeviceStatus
	devicestatus->set_default_properties(devicestatus_prop);
	//	Not Polled
	devicestatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(devicestatus);

	//	Attribute : SetPointStatus
	SetPointStatusAttrib	*setpointstatus = new SetPointStatusAttrib();
	Tango::UserDefaultAttrProp	setpointstatus_prop;
	//	description	not set for SetPointStatus
	//	label	not set for SetPointStatus
	//	unit	not set for SetPointStatus
	//	standard_unit	not set for SetPointStatus
	//	display_unit	not set for SetPointStatus
	//	format	not set for SetPointStatus
	//	max_value	not set for SetPointStatus
	//	min_value	not set for SetPointStatus
	//	max_alarm	not set for SetPointStatus
	//	min_alarm	not set for SetPointStatus
	//	max_warning	not set for SetPointStatus
	//	min_warning	not set for SetPointStatus
	//	delta_t	not set for SetPointStatus
	//	delta_val	not set for SetPointStatus
	setpointstatus->set_default_properties(setpointstatus_prop);
	//	Not Polled
	setpointstatus->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(setpointstatus);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(Tpg300Class::attribute_factory_after) ENABLED START -----*/

	//	Add your own code

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::pipe_factory()
 *	Description: Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void Tpg300Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(Tpg300Class::pipe_factory_before) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::pipe_factory_before
	/*----- PROTECTED REGION ID(Tpg300Class::pipe_factory_after) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::command_factory()
 *	Description: Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void Tpg300Class::command_factory()
{
	/*----- PROTECTED REGION ID(Tpg300Class::command_factory_before) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::command_factory_before


	//	Command SensorOn
	SensorOnClass	*pSensorOnCmd =
		new SensorOnClass("SensorOn",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"Channel\n[0,3]",
			"",
			Tango::EXPERT);
	command_list.push_back(pSensorOnCmd);

	//	Command SensorOff
	SensorOffClass	*pSensorOffCmd =
		new SensorOffClass("SensorOff",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"Channel\n[0,3]",
			"",
			Tango::EXPERT);
	command_list.push_back(pSensorOffCmd);

	//	Command WriteLowerThreshold
	WriteLowerThresholdClass	*pWriteLowerThresholdCmd =
		new WriteLowerThresholdClass("WriteLowerThreshold",
			Tango::DEVVAR_DOUBLEARRAY, Tango::DEV_VOID,
			"Setpoint, Pressure\n\nSetpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B\n\nPressure\n[1.0E-11, 9.9E+3]",
			"",
			Tango::EXPERT);
	command_list.push_back(pWriteLowerThresholdCmd);

	//	Command ReadLowerThreshold
	ReadLowerThresholdClass	*pReadLowerThresholdCmd =
		new ReadLowerThresholdClass("ReadLowerThreshold",
			Tango::DEV_SHORT, Tango::DEV_DOUBLE,
			"Setpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B",
			"Pressure",
			Tango::EXPERT);
	command_list.push_back(pReadLowerThresholdCmd);

	//	Command WriteUpperThreshold
	WriteUpperThresholdClass	*pWriteUpperThresholdCmd =
		new WriteUpperThresholdClass("WriteUpperThreshold",
			Tango::DEVVAR_DOUBLEARRAY, Tango::DEV_VOID,
			"Setpoint, Pressure\n\nSetpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B\n\nPressure\n[1.0E-11, 9.9E+3]",
			"",
			Tango::EXPERT);
	command_list.push_back(pWriteUpperThresholdCmd);

	//	Command ReadUpperThreshold
	ReadUpperThresholdClass	*pReadUpperThresholdCmd =
		new ReadUpperThresholdClass("ReadUpperThreshold",
			Tango::DEV_SHORT, Tango::DEV_DOUBLE,
			"Setpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B",
			"Pressure",
			Tango::EXPERT);
	command_list.push_back(pReadUpperThresholdCmd);

	//	Command ReadSensorSource
	ReadSensorSourceClass	*pReadSensorSourceCmd =
		new ReadSensorSourceClass("ReadSensorSource",
			Tango::DEV_SHORT, Tango::DEV_SHORT,
			"Setpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B",
			"Source\n0 -> No assignment\n1 -> Measuring circuit A1\n2 -> Measuring circuit A2\n3 -> Measuring circuit B1\n4 -> Measuring circuit B2\n5 -> Measuring circuit A1 (for self monitoring)\n6 -> Measuring circuit A2 (for self monitoring)\n7 -> Measuring circuit B1 (for self monitoring)\n8 -> Measuring circuit B2 (for self monitoring)",
			Tango::EXPERT);
	command_list.push_back(pReadSensorSourceCmd);

	//	Command WriteSensorSource
	WriteSensorSourceClass	*pWriteSensorSourceCmd =
		new WriteSensorSourceClass("WriteSensorSource",
			Tango::DEVVAR_SHORTARRAY, Tango::DEV_VOID,
			"Setpoint, Source\n\nSetpoint\n0 -> Switching function 1\n1 -> Switching function 2\n2 -> Switching function 3\n3 -> Switching function 4\n4 -> Switching function A\n5 -> Switching function B\n\nSource:\n0 -> No assignment\n1 -> Measuring circuit A1\n2 -> Measuring circuit A2\n3 -> Measuring circuit B1\n4 -> Measuring circuit B2\n5 -> Measuring circuit A1 (for self monitoring)\n6 -> Measuring circuit A2 (for self monitoring)\n7 -> Measuring circuit B1 (for self monitoring)\n8 -> Measuring circuit B2 (for self monitoring)",
			"",
			Tango::EXPERT);
	command_list.push_back(pWriteSensorSourceCmd);

	//	Command RegisterName
	RegisterNameClass	*pRegisterNameCmd =
		new RegisterNameClass("RegisterName",
			Tango::DEVVAR_LONGSTRINGARRAY, Tango::DEV_VOID,
			"Channel, Name\n\nChannel\n[0,3]\n\nName\nmax 64 characters",
			"",
			Tango::EXPERT);
	command_list.push_back(pRegisterNameCmd);

	//	Command UnregisterName
	UnregisterNameClass	*pUnregisterNameCmd =
		new UnregisterNameClass("UnregisterName",
			Tango::DEV_SHORT, Tango::DEV_VOID,
			"Channel\n[0,3]",
			"",
			Tango::EXPERT);
	command_list.push_back(pUnregisterNameCmd);

	/*----- PROTECTED REGION ID(Tpg300Class::command_factory_after) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		Tpg300Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the created attribute list
 */
//--------------------------------------------------------
void Tpg300Class::create_static_attribute_list(std::vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		std::string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	TANGO_LOG_INFO << defaultAttList.size() << " attributes in default list" << std::endl;

	/*----- PROTECTED REGION ID(Tpg300Class::create_static_att_list) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		Tpg300Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void Tpg300Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, std::vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((std::string)(*devlist_ptr)[i]).c_str());
		Tpg300 *dev = static_cast<Tpg300 *> (dev_impl);

		std::vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		std::vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			std::string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			std::vector<std::string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				TANGO_LOG_INFO << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << std::endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(Tpg300Class::erase_dynamic_attributes) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method     : Tpg300Class::get_attr_object_by_name()
 *	Description: returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *Tpg300Class::get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname)
{
	std::vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(Tpg300Class::Additional Methods) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	Tpg300Class::Additional Methods
} //	namespace
