/*
 * Tpg300Proxy.h
 *
 *  Created on: May 22, 2012
 *      Author: mdm
 */

#ifndef TPG300PROXY_H_
#define TPG300PROXY_H_

#include <tango.h>

namespace Tpg300_ns
{

class Tpg300Proxy
{
public:
	Tpg300Proxy(std::string, Tango::DevULong, Tango::DevULong);
	virtual ~Tpg300Proxy();

public:
	virtual std::string write_read(std::string);

protected:
	virtual void flush_data();
	virtual std::string  serial_in_out(std::string);
	virtual void print_request_debug(std::string);
	virtual void print_response_debug(std::string);

private:
	Tango::DeviceProxy* proxy;
	omni_mutex mutex;
	unsigned long secs;
	unsigned long nanosecs;
	static const char NAK = 0x15;
	static const char ENQ = 0x5;
	static const char LF = 0xA;
	static const char CR = 0xD;
};

}

#endif /* TPG300PROXY_H_ */
