/*
 * Tpg300SPManager.h
 *
 *  Created on: Jun 12, 2012
 *      Author: mdm
 */

#ifndef TPG300SPMANAGER_H_
#define TPG300SPMANAGER_H_

#include <tango.h>
#include <Tpg300Task.h>

#define SETPOINT_SIZE 6
#define POINT         0x2C

namespace Tpg300_ns
{

class Tpg300Proxy;

class Tpg300SPManager : public Tpg300Task
{
public:
	enum SetPoint{SETPOINT_0 = '1', SETPOINT_1 = '2', SETPOINT_2 = '3',
		SETPOINT_3 = '4', SETPOINT_A = 'A', SETPOINT_B = 'B'};

protected:
	struct SetPointConf
	{
		Tango::DevDouble lower_threshold;
		Tango::DevDouble upper_threshold;
		Tango::DevShort source;
	};

public:
	Tpg300SPManager(Tpg300Proxy*);
	virtual ~Tpg300SPManager() {};

public:
	virtual void update();
	virtual void get_setpoint_value(Tango::DevBoolean*, long);
    virtual Tango::DevDouble get_lower_threshold(SetPoint);
    virtual void set_lower_threshold(SetPoint, Tango::DevDouble);
    virtual Tango::DevDouble get_upper_threshold(SetPoint);
    virtual void set_upper_threshold(SetPoint, Tango::DevDouble);
    virtual Tango::DevShort get_source(SetPoint);
    virtual void set_source(SetPoint, Tango::DevShort);

protected:
    virtual SetPointConf get_setpoint_conf(SetPoint);
    virtual void set_setpoint_conf(SetPoint, SetPointConf);
    virtual double convert(double, int &);

private:
	Tpg300Proxy* proxy;
	omni_mutex mutex;
  bool valid;
  std::string trace;
	bool setpoints[SETPOINT_SIZE];

};

}

#endif /* TPG300SETPOINT_H_ */
