/*
 * Tpg300Thread.h
 *
 *  Created on: May 22, 2012
 *      Author: mdm
 */

#ifndef SAMPLINGTHREAD_H_
#define SAMPLINGTHREAD_H_

#include <tango.h>
#include <omnithread.h>

namespace Tpg300_ns
{

class Tpg300Channel;
class Tpg300SPManager;
class Tpg300Task;

class Tpg300Thread : public omni_thread
{
public:
	Tpg300Thread(std::vector<Tpg300Task *>, Tango::DevULong, omni_condition*);
	virtual void kill_thread();

protected:
	virtual ~Tpg300Thread();
	virtual void run(void *);
	virtual void sleep();

private:
	const std::vector<Tpg300Task *> task_vector;
	omni_condition* stop_condition;
	bool abort;
	unsigned long sleep_sec;
	unsigned long sleep_nsec;
	omni_mutex* condition_mutex;
	omni_condition* condition_var;
};

}

#endif /* SAMPLINGTHREAD_H_ */
