/*
 * Tpg300Utils.cpp
 *
 *  Created on: Jun 12, 2012
 *      Author: mdm
 */

#include "Tpg300Utils.h"

namespace Tpg300_ns
{

//--------------------------------------------------------
// Tpg300Utils::string_alloc()
//--------------------------------------------------------
void Tpg300Utils::string_alloc(Tango::DevString* str_pointer)
{
	*str_pointer = new char[STRING_SIZE];
}

//--------------------------------------------------------
// Tpg300Utils::string_free()
//--------------------------------------------------------
void Tpg300Utils::string_free(Tango::DevString* str_pointer)
{
	delete [] *str_pointer;
}

//--------------------------------------------------------
// Tpg300Utils::string_copy()
//--------------------------------------------------------
void Tpg300Utils::string_copy(Tango::DevString* str_pointer, string status_str)
{
	if(status_str.size()+1 >= STRING_SIZE)
	{
		delete [] *str_pointer;
		*str_pointer = new char[status_str.size()+1];
	}

	strcpy(*str_pointer, status_str.c_str());
}

//--------------------------------------------------------
// Tpg300Utils::get_trace()
//--------------------------------------------------------
string Tpg300Utils::get_trace(Tango::DevFailed & ex)
{
	std::stringstream error_msg;

    for (unsigned int i=0; i<ex.errors.length(); i++)
    {
            error_msg << ex.errors[i].reason.in() << endl;
            error_msg << ex.errors[i].desc.in() << endl;
            error_msg << ex.errors[i].origin.in() << endl;
    }

#ifdef _VERBOSE_DEBUG
    cout << " Error: " << error_msg.str() << endl;
#endif

    return error_msg.str();
}

}
