/*PROTECTED REGION ID(Tpg300::main.cpp) ENABLED START*/
static const char *RcsId = "$Id: main.cpp,v 1.4 2012-09-10 08:01:04 mdm Exp $";
//=============================================================================
//
// file :        Tpg300.cpp
//
// description : C++ source for the Tpg300 device server main.
//               The main rule is to initialise (and create) the Tango
//               system and to create the DServerClass singleton.
//                The main should be the same for every Tango device server.
//
// project :     Blzer Tpg 300.
//
// $Author: mdm $
//
// $Revision: 1.4 $
// $Date: 2012-09-10 08:01:04 $
//
// SVN only:
// $HeadURL:  $
//
// CVS only:
// $Source: /home/cvsadm/cvsroot/fermi/servers/tpg300/src/main.cpp,v $
// $Log: main.cpp,v $
// Revision 1.4  2012-09-10 08:01:04  mdm
// Bugfix in thread and on off commands
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <tango.h>


int main(int argc,char *argv[])
{
	Tango::Util *tg = NULL;
	try
	{
		// Initialise the device server
		//----------------------------------------
		tg = Tango::Util::init(argc,argv);

		// Create the device server singleton 
		//	which will create everything
		//----------------------------------------
		tg->server_init(false);

		// Run the endless loop
		//----------------------------------------
		cout << "Ready to accept request" << endl;
		tg->server_run();
	}
	catch (std::bad_alloc &)
	{
		cout << "Can't allocate memory to store device object !!!" << endl;
		cout << "Exiting" << endl;
	}
	catch (CORBA::Exception &e)
	{
		Tango::Except::print_exception(e);
		
		cout << "Received a CORBA_Exception" << endl;
		cout << "Exiting" << endl;
	}
	if (tg!=NULL)
		tg->server_cleanup();
	return(0);
}
/*PROTECTED REGION END*/	//	Tpg300::main.cpp
